//+------------------------------------------------------------------+
//|                                               Magelan v2.0MM.mq4 |
//+------------------------------------------------------------------+

extern bool Language_English = false; // : true-English, false-

extern string _____Traling_______ = "______Traling__________________";
extern bool   Traling          = false;
extern bool   TSProfitOnly = True;     //                  
extern int    TStop.Buy        = 50;//               
extern int    TStop.Sell       = 50;//                 
extern int    TrailingStep     = 3;//  

extern bool PEREVOROT = false;

extern int StartHour=08;
extern int StartMinute=01;
extern int StopHour=19;
extern int StopMinute=59;

extern int Slippage = 3;
extern bool   Use_ECN   = false;

extern int        Level_1 = 5;      //   
extern int        Level_2 = 25;     //   
extern int       tp_b           = 100;   //  
extern int       sl_b           = 100;   //  
extern int       tp_s           = 100;   //  
extern int       sl_s           = 100;   //  
extern int       Main_Level          = 5;    //    
extern int		  MagicNumber  = 111;	 //   
extern double    Lot          = 0;    //   
extern double Risk             = 0.3;
extern bool   Choice_method    = false;
extern bool   ShowComment   = True;         //  

extern string _____7_____ = "-----7-----";
extern int   eiPercent = 5;            //    :
                                       //  0 -  
                                       //  1 -    
                                       //  2 -    
                                       //  3 -    
                                       //  4 -    
                                       //  5 -    
extern int   eiOffsetY = 80;           //    
extern int   eiStepY   = 12;           //     
extern int   eiX1Row   = 3;            //  X  
extern int   eiX2Row   = 165;          //  X  
extern int   eiX3Row   = 230;          //  X  
extern int   eiX4Row   = 305;          //  X  
extern color ecText    = Gold;         //  
extern color ecProfit  = Lime;        //  
extern color ecLoss    = Red;    //  

double Box;                      //       
double TP_b,TP_s;                       //  -   
double SL_b,SL_s;                      //  -   

bool  gbDisabled = False;
#include <stdlib.mqh> 
bool   gbNoInit     = False;           //   
string msg[9][2];
int Language;
string char[256];
string e_mail = "forexinvest.ee";
string st;


//+==================================================================+
int init()
  {
//----
  Get_init();     

  gbNoInit=False;
  if (!IsTradeAllowed()){Message(msg[4][Language]);gbNoInit=True; return;}
    
  if (!IsLibrariesAllowed()){Message(msg[5][Language]);gbNoInit=True; return;}
    
  if (!IsTesting()) {if (IsExpertEnabled()) Message(msg[0][Language]);
  else Message(msg[1][Language]);}
  
  DeleteObjects();   
//----+
   for (int i = 0; i < 256; i++) char[i] = CharToStr(i);   
//----  
   Box = Main_Level*Point;
   TP_b  = tp_b*Point;
   SL_b  = sl_b*Point;
   TP_s  = tp_s*Point;
   SL_s  = sl_s*Point;   
   return(0);
  } 
//+==================================================================+
int deinit()
  {
  if (!IsTesting()) Comment("");
  DeleteObjects();GetDellName (e_mail); 
   return(0); 
  }
//+==================================================================+
int start()
  {
//----+
   if (gbDisabled){Message(msg[6][Language]); return;}
   if (gbNoInit){Message(msg[7][Language]); return;}
   
  if (ShowComment) {
    Comment("CurTime="+TimeToStr(TimeCurrent(), TIME_MINUTES)
            ,"\nBalance = "+DoubleToStr(AccountBalance(), 2)
            ,"\nEquity = "+DoubleToStr(AccountEquity(), 2)
            ,"\nDrawdown Percent = "+DoubleToStr((AccountEquity()-AccountBalance())/(AccountBalance()/100) , 2)            
            ,"\n    "+st
           );
    status();
  } else {Comment("");DeleteObjects();}
//----+
  if(Traling)SimpleTrailing(Symbol(),-1,MagicNumber);
  //----
   static bool pusk_exp = false;         //       
   static double ema_fast_curr = 0.0;    //  ,     ema 
   static double ema_slow_curr = 0.0;    //  ,     ema 
   static double ema_fast_prev = 0.0;    //  ,     ema   
   static double ema_slow_prev = 0.0;    //  ,     ema   
   static datetime time_for_shift_1;     //  ,        
   static int count = 0;                 //  ,    ,   
   static bool finish_count = false;     //       
   int n;                                // -
   double L;                             //  
   //-----------------------------------------------------------------
   //   .   
   //-----------------------------------------------------------------
   if (pusk_exp == false)
   {
    for (n = 100000; n >= 1; n--)
     {
      L = renko(iClose(NULL, 0, n)); //   ,  L != -1,  
      //--------------------------------------------------------------
      //     L != -1  ...
      //--------------------------------------------------------------
      if (L != -1)
      {
       ema_fast_curr = ema_fast_prev+(2.0/( Level_1+1))*(L-ema_fast_prev);
       ema_slow_curr = ema_slow_prev+(2.0/( Level_2+1))*(L-ema_slow_prev);
       //-------------------------------------------------------------
       //    ,    
       //-------------------------------------------------------------
       ema_fast_prev = ema_fast_curr;
       ema_slow_prev = ema_slow_curr;
       count++;
      } // if (L != -1)
     } // for (n = 1000; n >= 1; n--)
     time_for_shift_1 = iTime(NULL, 0, 1); //  ,        
     pusk_exp = true;    //  1-  
     return(0);          //     
   } // if (pusk_exp == false)
   //-----------------------------------------------------------------
   //   
   //-----------------------------------------------------------------
   if (finish_count == false)
   {
    //Print("    = ", count);
    finish_count = true; //       
   } // if (finish_count == false)
   int prev_shift_was_1 = iBarShift(NULL, 0, time_for_shift_1, false); //     
   for (n = prev_shift_was_1; n>= 1; n--)
   {
    L = renko(iClose(NULL, 0, n)); //   ,  L != -1,  
    //--------------------------------------------------------------
    //     L != -1  ...
    //--------------------------------------------------------------
    if (L != -1)
    {
     ema_fast_curr = ema_fast_prev+(2.0/( Level_1+1))*(L-ema_fast_prev);
     ema_slow_curr = ema_slow_prev+(2.0/( Level_2+1))*(L-ema_slow_prev);
     //-------------------------------------------------------------
     //  1-      
     //-------------------------------------------------------------
     if (n == 1)
     {
      //------------------------------------------------------------
      //         
      //------------------------------------------------------------
      if ((ema_fast_curr > ema_slow_curr) && (ema_fast_prev < ema_slow_prev))
      {
       order_commander("BUY");
      } // if ((ema_fast_curr > ema_slow_curr) && (ema_fast_prev < ema_slow_prev))
      //------------------------------------------------------------
      //         
      //------------------------------------------------------------
      if ((ema_fast_curr < ema_slow_curr) && (ema_fast_prev > ema_slow_prev))
      {
       order_commander("SELL");
      } // if ((ema_fast_curr < ema_slow_curr) && (ema_fast_prev > ema_slow_prev))
      //------------------------------------------------------------
     } // if (n == 1)
     ema_fast_prev = ema_fast_curr;
     ema_slow_prev = ema_slow_curr;
    } // if (L != -1)   
   } // for (n = prev_shift_was_1; n>= 1; n--)
   time_for_shift_1 = iTime(NULL, 0, 1); //  ,          
   return(0); //     
  } // int start()

//+==================================================================+
//|                                                        |
//+==================================================================+

//+==================================================================+
//|  1:                      |
//+==================================================================+
double renko(double curr_price)
  {
   static double R;                 //       
   static bool pusk_1 = false;      //       
   //-----------------------------------------------------------------
   //        
   //-----------------------------------------------------------------
   if (pusk_1 == false)
   {
    R = (MathFloor((curr_price-0.0)/Box))*Box+0.0;
    pusk_1 = true;    //  1-     
    return(R); //   
   } // if (pusk_1 == false)
   //-----------------------------------------------------------------
   //    
   //-----------------------------------------------------------------
   if (curr_price >= R+Box) //  
   {
    R = R+Box;
    return(R); //   
   } // if (curr_price >= R+Box)  //  
   //-----------------------------------------------------------------
   if (curr_price <= R-Box) //  
   {
    R = R-Box;
    return(R); //   
   } // if (curr_price <= R-Box) //  
   //-----------------------------------------------------------------
   return(-1); //     ,    -1
  } // double renko(double curr_price)

//+==================================================================+
//|  2:                                   |
//+==================================================================+
int order_commander(string napravlenie)
  {
   int _OrdersTotal = OrdersTotal();
	//----
 if(PEREVOROT){
	for (int z = _OrdersTotal - 1; z >= 0; z --)
	{
	 if (!OrderSelect(z, SELECT_BY_POS, MODE_TRADES))continue;
	 if (OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol())continue; 
	 if (OrderType() == OP_BUY)
	 {
	  if (napravlenie == "SELL")ClosePosBySelect();
	 }
    if (OrderType() == OP_SELL)
    {
     if (napravlenie == "BUY")ClosePosBySelect();
    }
   }} 
   //-----
if(isTradeTimeInt(StartHour,StartMinute,StopHour,StopMinute))
{
   double StopLoss, TakeProfit;
   if (napravlenie == "SELL")
   {
    if (SL_s > 0 ) StopLoss = NormalizeDouble(Ask + SL_s, Digits);else StopLoss = 0.0;
    if (TP_s > 0 )TakeProfit = NormalizeDouble(Ask - TP_s, Digits);else TakeProfit = 0.0;
    if(!ExistPositions(Symbol(),OP_SELL,MagicNumber))OpenPosition(Symbol(),OP_SELL,GetLot(),StopLoss,TakeProfit,MagicNumber);
   }
   
   if (napravlenie == "BUY")
   {
    if (SL_b > 0 )StopLoss = NormalizeDouble(Bid - SL_b, Digits); else StopLoss = 0.0;    
    if(TP_b>0)TakeProfit = NormalizeDouble(Bid + TP_b, Digits); else TakeProfit = 0.0;
    if(!ExistPositions(Symbol(),OP_BUY,MagicNumber))OpenPosition(Symbol(),OP_BUY,GetLot(),StopLoss,TakeProfit,MagicNumber);    
   }
}      
   return(0); 
  } 
//==============================================================================================================
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL ) {
    for (it=1; it<=5; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_ASK),Digits);
      pb=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_BID),Digits);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=Aqua;
      } else {
        pp=pa; clClose=Yellow;
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
      if (fc) {
         PlaySound("ok"); break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  } else Print("  . Close ",GetNameOP(OrderType()));
}
//----
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0) {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;
  string   lsComm="yuriytokman@gmail.com "+WindowExpertName()+" "+GetNameTF(Period());

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=Lime; else clOpen=Red;
  for (it=1; it<=5; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (Use_ECN)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, lsComm, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, 0, clOpen);
    if (ticket>0) {
      PlaySound("ok"); break;
    } else {
      err=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          PlaySound("ok"); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (Use_ECN && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=5; it++) {
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        PlaySound("ok"); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}
//----
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("UnknownPeriod");
  }
}
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
//----
 double GetLot()
  {
   double metod  = 0;
   if(Choice_method)metod = AccountBalance();
   else metod = AccountFreeMargin();
   double MinLot = MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double Prots = Risk/100;
   double Lotsi=MathFloor(metod*Prots/MarketInfo(Symbol(),MODE_MARGINREQUIRED)
               /MarketInfo(Symbol(),MODE_LOTSTEP))*MarketInfo(Symbol(),MODE_LOTSTEP);
   if(Lot>0)Lotsi=Lot;
   if(Lotsi<MinLot)Lotsi=MinLot;
   if(Lotsi>MaxLot)Lotsi=MaxLot;               
   return(Lotsi);
  }
//----
bool isTradeTimeInt(int hb=0, int mb=0, int he=0, int me=0) {
  datetime db, de;           //     
  int      hc;               //     

  db=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+hb+":"+mb);
  de=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+he+":"+me);
  hc=TimeHour(TimeCurrent());
  if (db>=de) {
    if (hc>=he) de+=24*60*60; else db-=24*60*60;
  }

  if (TimeCurrent()>=db && TimeCurrent()<=de) return(True);
  else return(False);
}
//+----------------------------------------------------------------------------+
void SimpleTrailing(string sy="", int op=-1, int mn=-1) {
  double po, pp;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        po=Point;//MarketInfo(OrderSymbol(), MODE_POINT);
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(OrderSymbol(), MODE_BID);
            if (!TSProfitOnly || pp-OrderOpenPrice()>TStop.Buy*po) {
              if (OrderStopLoss()<pp-(TStop.Buy+TrailingStep-1)*po) {
                ModifyOrder(-1, pp-TStop.Buy*po, -1);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(OrderSymbol(), MODE_ASK);
            if (!TSProfitOnly || OrderOpenPrice()-pp>TStop.Sell*po) {
              if (OrderStopLoss()>pp+(TStop.Sell+TrailingStep-1)*po || OrderStopLoss()==0) {
                ModifyOrder(-1, pp+TStop.Sell*po, -1);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+
 void Get_init()
 {
  Language =Language_English;  

  msg[0][1]="Adviser will is started by next tick";
  msg[0][0]="    ";
  
  msg[1][1]="Button is not pressed \"Enable experts for running\"";
  msg[1][0]="  \"  \"";
  
  msg[2][1]="IS ABSENT relationship with trade server\n"+"Adviser is STOPPED";
  msg[2][0]="    \n"+" ";
            
  msg[3][1]="Button is not pressed \"Enable experts for running\"\n"+"Expert Adviser is STOPPED";
  msg[3][0]="  \"  \"\n"+" ";

  msg[4][1]="For normal job of the adviser  it is necessary\n " + " To permit to the adviser to trade ";
  msg[4][0]="    \n"+"  ";

  msg[5][1]=" For normal job of the adviser it is necessary\n " + " To permit import from the external experts ";
  msg[5][0]="    \n"+"    ";
  
  msg[6][1]="A Critical mistake! The adviser IS STOPPED! ";
  msg[6][0]=" !  !";
  
  msg[7][1]="The adviser was not possible to initialize! ";
  msg[7][0]="   !";
  
  msg[8][1]=" The rules of the license agreement Are broken.\n"+" THE ADVISER IS STOPPED! Address to the developer: ytg@forexinvest.ee ";
  msg[8][0]="    .\n"+"   !   : ytg@forexinvest.ee ";  
 }
//----
//+----------------------------------------------------------------------------+
void DeleteObjects() {
  string st="iProfit";
  int    i, j;

  for (i=0; i<10; i++) {
    for (j=1; j<8; j++) ObjectDelete(st+i+j);
  }
}
//----
 void GetDellName (string name_n = "ytg_")
  {
   string vName;
   for(int i=ObjectsTotal()-1; i>=0;i--)
    {
     vName = ObjectName(i);
     if (StringFind(vName,name_n) !=-1) ObjectDelete(vName);
    }  
  }
//----
//----
void status() {
  datetime d0, d1, d2, d3, d4, d5, d6, d7, d8;

  d0=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));
  while (TimeDayOfWeek(d0)<1 || TimeDayOfWeek(d0)>5) d0-=24*60*60;
  d1=d0-24*60*60;
  while (TimeDayOfWeek(d1)<1 || TimeDayOfWeek(d1)>5) d1-=24*60*60;
  d2=d1-24*60*60;
  while (TimeDayOfWeek(d2)<1 || TimeDayOfWeek(d2)>5) d2-=24*60*60;
  d3=d2-24*60*60;
  while (TimeDayOfWeek(d3)<1 || TimeDayOfWeek(d3)>5) d3-=24*60*60;
  d4=d3-24*60*60;
  while (TimeDayOfWeek(d4)<1 || TimeDayOfWeek(d4)>5) d4-=24*60*60;
  d5=DateOfMonday();
  d6=StrToTime(Year()+"."+Month()+".01");
  d7=DateBeginQuarter();
  d8=StrToTime(Year()+".01.01");

  double tu=GetProfitOpenPosInPoint();
  double u0=GetProfitFromDateInPoint("", -1, -1, d0);
  double u1=GetProfitFromDateInPoint("", -1, -1, d1)-u0;
  double u2=GetProfitFromDateInPoint("", -1, -1, d2)-u1-u0;
  double u3=GetProfitFromDateInPoint("", -1, -1, d3)-u2-u1-u0;
  double u4=GetProfitFromDateInPoint("", -1, -1, d4)-u3-u2-u1-u0;
  double u5=GetProfitFromDateInPoint("", -1, -1, d5);
  double u6=GetProfitFromDateInPoint("", -1, -1, d6);
  double u7=GetProfitFromDateInPoint("", -1, -1, d7);
  double u8=GetProfitFromDateInPoint("", -1, -1, d8);

  double tb=AccountBalance(), tp=AccountProfit();
  double p0=GetProfitFromDateInCurrency("", -1, -1, d0);
  double p1=GetProfitFromDateInCurrency("", -1, -1, d1)-p0;
  double p2=GetProfitFromDateInCurrency("", -1, -1, d2)-p1-p0;
  double p3=GetProfitFromDateInCurrency("", -1, -1, d3)-p2-p1-p0;
  double p4=GetProfitFromDateInCurrency("", -1, -1, d4)-p3-p2-p1-p0;
  double p5=GetProfitFromDateInCurrency("", -1, -1, d5);
  double p6=GetProfitFromDateInCurrency("", -1, -1, d6);
  double p7=GetProfitFromDateInCurrency("", -1, -1, d7);
  double p8=GetProfitFromDateInCurrency("", -1, -1, d8);

  //  
  double h0=GetChangeBalance("", -1, -1, d0);
  double h5=GetChangeBalance("", -1, -1, d5);
  double h6=GetChangeBalance("", -1, -1, d6);
  double h7=GetChangeBalance("", -1, -1, d7);
  double h8=GetChangeBalance("", -1, -1, d8);

  switch (eiPercent) {
    case 0 :            st=""          ; break;
    case 1 : tb-=p0+h0; st="  "     ; break;
    case 2 : tb-=p5+h5; st="  "  ; break;
    case 3 : tb-=p6+h6; st="  "  ; break;
    case 4 : tb-=p7+h7; st="  "; break;
    default: tb-=p8+h8; st="  "    ; break;
  }
  double tr=tp*100/tb;
  double r0=p0*100/tb;
  double r1=p1*100/tb;
  double r2=p2*100/tb;
  double r3=p3*100/tb;
  double r4=p4*100/tb;
  double r5=p5*100/tb;
  double r6=p6*100/tb;
  double r7=p7*100/tb;
  double r8=p8*100/tb;

  SetLabel("iProfit05", "", ecText, eiX1Row+25, eiOffsetY);
  SetLabel("iProfit06", " ", ecText, eiX2Row-15, eiOffsetY);
  SetLabel("iProfit07", " ", ecText, eiX3Row+35, eiOffsetY);

  SetLabel("iProfit11", " ", ecText, eiX1Row, eiOffsetY+1*eiStepY);
  SetLabel("iProfit21", "  ", ecText, eiX1Row, eiOffsetY+2*eiStepY);
  SetLabel("iProfit31", "  "+TimeToStr(d1, TIME_DATE), ecText, eiX1Row, eiOffsetY+3*eiStepY);
  SetLabel("iProfit41", "  "+TimeToStr(d2, TIME_DATE), ecText, eiX1Row, eiOffsetY+4*eiStepY);
  SetLabel("iProfit51", "  "+TimeToStr(d3, TIME_DATE), ecText, eiX1Row, eiOffsetY+5*eiStepY);
  SetLabel("iProfit61", "  "+TimeToStr(d4, TIME_DATE), ecText, eiX1Row, eiOffsetY+6*eiStepY);
  SetLabel("iProfit71", "  ", ecText, eiX1Row, eiOffsetY+7*eiStepY);
  SetLabel("iProfit81", "  ", ecText, eiX1Row, eiOffsetY+8*eiStepY);
  SetLabel("iProfit91", "  ", ecText, eiX1Row, eiOffsetY+9*eiStepY);
  SetLabel("iProfit01", "  ", ecText, eiX1Row, eiOffsetY+10*eiStepY);

  SetLabel("iProfit12", DoubleToStr(tu, 0), ColorOnSign(tp), eiX2Row, eiOffsetY+1*eiStepY);
  SetLabel("iProfit22", DoubleToStr(u0, 0), ColorOnSign(u0), eiX2Row, eiOffsetY+2*eiStepY);
  SetLabel("iProfit32", DoubleToStr(u1, 0), ColorOnSign(u1), eiX2Row, eiOffsetY+3*eiStepY);
  SetLabel("iProfit42", DoubleToStr(u2, 0), ColorOnSign(u2), eiX2Row, eiOffsetY+4*eiStepY);
  SetLabel("iProfit52", DoubleToStr(u3, 0), ColorOnSign(u3), eiX2Row, eiOffsetY+5*eiStepY);
  SetLabel("iProfit62", DoubleToStr(u4, 0), ColorOnSign(u4), eiX2Row, eiOffsetY+6*eiStepY);
  SetLabel("iProfit72", DoubleToStr(u5, 0), ColorOnSign(u5), eiX2Row, eiOffsetY+7*eiStepY);
  SetLabel("iProfit82", DoubleToStr(u6, 0), ColorOnSign(u6), eiX2Row, eiOffsetY+8*eiStepY);
  SetLabel("iProfit92", DoubleToStr(u7, 0), ColorOnSign(u7), eiX2Row, eiOffsetY+9*eiStepY);
  SetLabel("iProfit02", DoubleToStr(u8, 0), ColorOnSign(u8), eiX2Row, eiOffsetY+10*eiStepY);

  SetLabel("iProfit13", DoubleToStr(tp, 2), ColorOnSign(tp), eiX3Row, eiOffsetY+1*eiStepY);
  SetLabel("iProfit23", DoubleToStr(p0, 2), ColorOnSign(p0), eiX3Row, eiOffsetY+2*eiStepY);
  SetLabel("iProfit33", DoubleToStr(p1, 2), ColorOnSign(p1), eiX3Row, eiOffsetY+3*eiStepY);
  SetLabel("iProfit43", DoubleToStr(p2, 2), ColorOnSign(p2), eiX3Row, eiOffsetY+4*eiStepY);
  SetLabel("iProfit53", DoubleToStr(p3, 2), ColorOnSign(p3), eiX3Row, eiOffsetY+5*eiStepY);
  SetLabel("iProfit63", DoubleToStr(p4, 2), ColorOnSign(p4), eiX3Row, eiOffsetY+6*eiStepY);
  SetLabel("iProfit73", DoubleToStr(p5, 2), ColorOnSign(p5), eiX3Row, eiOffsetY+7*eiStepY);
  SetLabel("iProfit83", DoubleToStr(p6, 2), ColorOnSign(p6), eiX3Row, eiOffsetY+8*eiStepY);
  SetLabel("iProfit93", DoubleToStr(p7, 2), ColorOnSign(p7), eiX3Row, eiOffsetY+9*eiStepY);
  SetLabel("iProfit03", DoubleToStr(p8, 2), ColorOnSign(p8), eiX3Row, eiOffsetY+10*eiStepY);

  SetLabel("iProfit14", DoubleToStr(tr, 2)+" %", ColorOnSign(tr), eiX4Row, eiOffsetY+1*eiStepY);
  SetLabel("iProfit24", DoubleToStr(r0, 2)+" %", ColorOnSign(r0), eiX4Row, eiOffsetY+2*eiStepY);
  SetLabel("iProfit34", DoubleToStr(r1, 2)+" %", ColorOnSign(r1), eiX4Row, eiOffsetY+3*eiStepY);
  SetLabel("iProfit44", DoubleToStr(r2, 2)+" %", ColorOnSign(r2), eiX4Row, eiOffsetY+4*eiStepY);
  SetLabel("iProfit54", DoubleToStr(r3, 2)+" %", ColorOnSign(r3), eiX4Row, eiOffsetY+5*eiStepY);
  SetLabel("iProfit64", DoubleToStr(r4, 2)+" %", ColorOnSign(r4), eiX4Row, eiOffsetY+6*eiStepY);
  SetLabel("iProfit74", DoubleToStr(r5, 2)+" %", ColorOnSign(r5), eiX4Row, eiOffsetY+7*eiStepY);
  SetLabel("iProfit84", DoubleToStr(r6, 2)+" %", ColorOnSign(r6), eiX4Row, eiOffsetY+8*eiStepY);
  SetLabel("iProfit94", DoubleToStr(r7, 2)+" %", ColorOnSign(r7), eiX4Row, eiOffsetY+9*eiStepY);
  SetLabel("iProfit04", DoubleToStr(r8, 2)+" %", ColorOnSign(r8), eiX4Row, eiOffsetY+10*eiStepY);

  //Print("    "+st);
}
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
color ColorOnSign(double nu) {
  color lcColor=ecText;

  if (nu>0) lcColor=ecProfit;
  if (nu<0) lcColor=ecLoss;

  return(lcColor);
}
//+----------------------------------------------------------------------------+
datetime DateBeginQuarter(int nk=0) {
  int ye=Year()-MathFloor(nk/4);
  nk=MathMod(nk, 4);
  int mo=Month()-MathMod(Month()+2, 3)+3*nk;
  if (mo<1) {
    mo+=12;
    ye--;
  }
  if (mo>12) {
    mo-=12;
    ye++;
  }

  return(StrToTime(ye+"."+mo+".01"));
}
//+----------------------------------------------------------------------------+
datetime DateOfMonday(int no=0) {
  datetime dt=StrToTime(TimeToStr(TimeCurrent(), TIME_DATE));

  while (TimeDayOfWeek(dt)!=1) dt-=24*60*60;
  dt+=no*7*24*60*60;

  return(dt);
}
//+----------------------------------------------------------------------------+
double GetChangeBalance(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0;
  int    i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==6) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (dt<OrderCloseTime()) {
              if (OrderProfit()<0) p+=OrderProfit();
            }
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+
double GetProfitFromDateInCurrency(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0;
  int    i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (dt<OrderCloseTime()) {
              p+=OrderProfit()+OrderCommission()+OrderSwap();
            }
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+
double GetProfitFromDateInPoint(string sy="", int op=-1, int mn=-1, datetime dt=0)
{
  double p=0, po;
  int    i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (dt<OrderCloseTime()) {
              po=MarketInfo(OrderSymbol(), MODE_POINT);
              if (po==0) if (StringFind(sy, "JPY")<0) po=0.0001; else po=0.01;
              if (OrderType()==OP_BUY) {
                p+=(OrderClosePrice()-OrderOpenPrice())/po;
              }
              if (OrderType()==OP_SELL) {
                p+=(OrderOpenPrice()-OrderClosePrice())/po;
              }
            }
          }
        }
      }
    }
  }
  return(p);
}
//+----------------------------------------------------------------------------+
int GetProfitOpenPosInPoint(string sy="", int op=-1, int mn=-1) {
  double p;
  int    i, k=OrdersTotal(), pr=0;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          p=MarketInfo(OrderSymbol(), MODE_POINT);
          if (p==0) if (StringFind(OrderSymbol(), "JPY")<0) p=0.0001; else p=0.01;
          if (OrderType()==OP_BUY) {
            pr+=(MarketInfo(OrderSymbol(), MODE_BID)-OrderOpenPrice())/p;
          }
          if (OrderType()==OP_SELL) {
            pr+=(OrderOpenPrice()-MarketInfo(OrderSymbol(), MODE_ASK))/p;
          }
        }
      }
    }
  }
  return(pr);
}
//+----------------------------------------------------------------------------+
void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9) {
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0,0);
  ObjectSetText(nm, tx, fs);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}
//+----------------------------------------------------------------------------+





